Golgi_NaP_defs = "Golgi_NaP.m" ;
autoload ("Golgi_NaP" , Golgi_NaP_defs) ;
autoload ("Golgi_NaP_init" , Golgi_NaP_defs) ;
global celsius
celsius = 23;
Golgi_NaP_init ;
y0 = Golgi_NaP_init (-65) ;
global N ;
N = length (y0) ;
function is = Golgi_NaP_currents_odepkg (y)
  global N ;
  global i_NaP ;
  t = y (1) ;
  s = y (2:N+1) ;
  y1 = Golgi_NaP (t , s) ;
  is = [ t i_NaP ] ;
endfunction
function is = Golgi_NaP_currents_lsode (y)
  global N ;
  global i_NaP ;
  t = y (1) ;
  s = y (2:N+1) ;
  y1 = Golgi_NaP (s , t) ;
  is = [ t i_NaP ] ;
endfunction
function ys = Golgi_NaP_vclamp_run1_odepkg (N , dt , vchold , vchdur , vcbase , vcdur)
  global reltol abstol
  P = odeset ("RelTol" , reltol , "AbsTol" , abstol , "MaxStep" , 1 , "InitialStep" , dt) ;
  t0 = 0.0 ;
  t1 = t0+vchdur ;
  t2 = t1 ;
  t3 = t2+vcdur ;
  t4 = t3 ;
  t5 = t4+vchdur ;
  vinit = vchold ;
  y0 = Golgi_NaP_init (vinit)
  sol = ode2r (@Golgi_NaP , [ t0 t1 ] , y0 , P) ;
  ys = [ sol.x sol.y ] ;
  vinit = vcbase ;
  y0 = sol.y (size (sol.y) (1) , :) ' ; y0 (1) = vinit
  sol = ode2r (@Golgi_NaP , [ t2 t3 ] , y0 , P) ;
  ys = vertcat (ys , [ sol.x sol.y ]) ;
  vinit = vchold ;
  y0 = sol.y (size (sol.y) (1) , :) ' ; y0 (1) = vinit
  sol = ode2r (@Golgi_NaP , [ t4 t5 ] , y0 , P) ;
  ys = vertcat (ys , [ sol.x sol.y ]) ;
endfunction ;
function ys = Golgi_NaP_vclamp_run1_lsode (N , dt , vchold , vchdur , vcbase , vcdur)
  global reltol abstol
  lsode_options ("absolute tolerance" , abstol) ;
  lsode_options ("relative tolerance" , reltol) ;
  lsode_options ("integration method" , "bdf") ;
  lsode_options ("initial step size" , dt) ;
  t0 = 0.0 ;
  t1 = t0+vchdur ;
  thold0 = linspace (t0 , t1 , (t1-t0) /dt) ;
  t2 = t1 ;
  t3 = t2+vcdur ;
  tclamp = linspace (t2 , t3 , (t3-t2) /dt) ;
  t4 = t3 ;
  t5 = t4+vchdur ;
  thold1 = linspace (t4 , t5 , (t5-t4) /dt) ;
  vinit = vchold ;
  y0 = Golgi_NaP_init (vinit)
  y = lsode (@Golgi_NaP , y0 , thold0) ;
  ys = [ thold0' y ] ;
  vinit = vcbase ;
  y0 = y (size (y) (1) , :) ' ; y0 (1) = vinit
  y = lsode (@Golgi_NaP , y0 , tclamp) ;
  ys = vertcat (ys , [ tclamp' y ]) ;
  vinit = vchold ;
  y0 = y (size (y) (1) , :) ' ; y0 (1) = vinit
  y = lsode (@Golgi_NaP , y0 , thold1) ;
  ys = vertcat (ys , [ thold1' y ]) ;
endfunction
function ilog = Golgi_NaP_vclamp_fn (N , dt , vchold , vchdur , vcbase , vcdur , vcinc , vcsteps)
  vc = vcbase ;
  ys = cell (1 , vcsteps) ;
  for i = 1:vcsteps
    y = Golgi_NaP_vclamp_run1_odepkg (N , dt , vchold , vchdur , vc , vcdur) ;
    ys (i) = y ;
    vc = vc + vcinc ;
  endfor ;
  ilog = cell (vcsteps , 1) ;
  for i = 1:vcsteps
    ilogv = [ ] ;
    n = size (ys {i}) (1) ;
    for j = 1:n
      next = Golgi_NaP_currents_odepkg (ys {i} (j , :)) ;
      ilogv = vertcat (ilogv , next) ;
    endfor ;
    ilog {i} = ilogv ;
  endfor ;
endfunction
global reltol abstol
reltol = 1e-03 ;
abstol = 1e-03 ;
dt = 0.001 ;
## i_NaP plot
i_NaP_index = 2 ;
global comp211_vchold comp211_vchdur comp211_vcbase comp211_vcbdur comp211_vcinc comp211_vcsteps
Golgi_NaP_ilog = Golgi_NaP_vclamp_fn (N , dt , comp211_vchold , comp211_vchdur , comp211_vcbase , comp211_vcbdur , comp211_vcinc , comp211_vcsteps) ;
subplot (1 , 3 , 1) ;
plot (Golgi_NaP_ilog{1}(:,1) , Golgi_NaP_ilog{1}(:,i_NaP_index) , Golgi_NaP_ilog{2}(:,1) , Golgi_NaP_ilog{2}(:,i_NaP_index) , Golgi_NaP_ilog{3}(:,1) , Golgi_NaP_ilog{3}(:,i_NaP_index) , Golgi_NaP_ilog{4}(:,1) , Golgi_NaP_ilog{4}(:,i_NaP_index) , Golgi_NaP_ilog{5}(:,1) , Golgi_NaP_ilog{5}(:,i_NaP_index) , Golgi_NaP_ilog{6}(:,1) , Golgi_NaP_ilog{6}(:,i_NaP_index) , Golgi_NaP_ilog{7}(:,1) , Golgi_NaP_ilog{7}(:,i_NaP_index) , Golgi_NaP_ilog{8}(:,1) , Golgi_NaP_ilog{8}(:,i_NaP_index) , Golgi_NaP_ilog{9}(:,1) , Golgi_NaP_ilog{9}(:,i_NaP_index)) ;
NaP_log = vertcat ([Golgi_NaP_ilog{1}(:,1),Golgi_NaP_ilog{1}(:,i_NaP_index)] , [Golgi_NaP_ilog{2}(:,1),Golgi_NaP_ilog{2}(:,i_NaP_index)] , [Golgi_NaP_ilog{3}(:,1),Golgi_NaP_ilog{3}(:,i_NaP_index)] , [Golgi_NaP_ilog{4}(:,1),Golgi_NaP_ilog{4}(:,i_NaP_index)] , [Golgi_NaP_ilog{5}(:,1),Golgi_NaP_ilog{5}(:,i_NaP_index)] , [Golgi_NaP_ilog{6}(:,1),Golgi_NaP_ilog{6}(:,i_NaP_index)] , [Golgi_NaP_ilog{7}(:,1),Golgi_NaP_ilog{7}(:,i_NaP_index)] , [Golgi_NaP_ilog{8}(:,1),Golgi_NaP_ilog{8}(:,i_NaP_index)] , [Golgi_NaP_ilog{9}(:,1),Golgi_NaP_ilog{9}(:,i_NaP_index)]) ;
save -ascii "NaP.dat" NaP_log ;
